#pragma once
#include <fstream>
#include <set>
#include <iostream>
#include <string.h>
#include <map>

class AviaInfo {
    int flight_number = 0;
    int departure_data = 0;
    int departure_time = 0;
    char destination[30];
    char surname[30];
    int number_of_luggage = 0;
    int weight_of_luggage = 0;
public:
    AviaInfo():
    flight_number(0), departure_data(0), departure_time(0), destination(""), surname(""), number_of_luggage(0),
    weight_of_luggage(0){}

    AviaInfo(int n_flight_number, int n_departure_data, int n_departure_time, char* n_destination, char* n_surname,
             int n_number_of_luggage, int n_weight_of_luggage): flight_number(n_flight_number), departure_data(n_departure_data),
             departure_time(n_departure_time), number_of_luggage(n_number_of_luggage), weight_of_luggage(n_weight_of_luggage){
        strncpy(destination, n_destination, 30);
        strncpy(surname, n_surname, 30);
    }

    bool operator==(const AviaInfo& info) const{
        return (strcmp(surname, info.surname) == 0 && strcmp(destination, info.destination) == 0 &&
        flight_number == info.flight_number && departure_data == info.departure_data &&
        departure_time == info.departure_time && number_of_luggage == info.number_of_luggage &&
        weight_of_luggage == info.weight_of_luggage);
        }


    bool operator!=(const AviaInfo& info) const{
            return !(*this == info);
        }


    AviaInfo& operator=(const AviaInfo& info);
    friend std::istream& operator>>(std::istream& p_in, AviaInfo& info);
    friend std::ostream& operator<<(std::ostream& p_out, const AviaInfo& info);

    friend void make_file();
    friend void make_map(std::map<int, AviaInfo>& map);
    friend void print_out();
    friend void delete_line(int erasing_line);

    friend void search_by_flight_number(const int& p_flight_number);
    friend void search_by_departure_data(const int& p_departure_data);
    friend void search_by_weight_of_luggage(const int& normal_weight_of_luggage);
    friend void search_by_destination(const std::string& p_destination);
};

AviaInfo& AviaInfo::operator=(const AviaInfo& info){
    if (this == &info){
        return *this;
    }
    flight_number = info.flight_number;
    departure_data = info.departure_data;
    departure_time = info.departure_time;
    strcpy(destination, info.destination);
    strcpy(surname, info.surname);
    number_of_luggage = info.number_of_luggage;
    weight_of_luggage = info.weight_of_luggage;

    return *this;
}

std::istream& operator>>(std::istream& p_in, AviaInfo& info){
    std::cout << "Enter info about flight" << std::endl;
    std::cout << "flight number, departure data, departure time, destination, surname,"
                 " number of luggage, weight of luggage" << std::endl;
    p_in  >> info.flight_number >> info.departure_time >> info.flight_number >> info.destination >> info.surname >>
          info.number_of_luggage >>  info.weight_of_luggage;
    return p_in;
}
std::ostream& operator<<(std::ostream& p_out, const AviaInfo& info){
    p_out <<  "flight number: " << info.flight_number << std::endl <<
          "departure data: " << info.departure_time << std::endl <<
          "departure time: " << info.flight_number << std::endl <<
          "destination: " << info.destination << std::endl <<
          "surname: " << info.surname << std::endl <<
          "number of luggage: " << info.number_of_luggage << std::endl <<
          "weight of luggage: " << info.weight_of_luggage << std::endl;
    return p_out;

}